import { StorageEngine } from './storage';
export class LocalStorage extends StorageEngine {
    constructor(options = {}) {
        super();
    }
    get(key) {
        return new Promise((resolve, reject) => {
            try {
                let value = window.localStorage.getItem(key);
                resolve(value);
            }
            catch (e) {
                reject(e);
            }
        });
    }
    set(key, value) {
        return new Promise((resolve, reject) => {
            try {
                window.localStorage.setItem(key, value);
                resolve();
            }
            catch (e) {
                reject(e);
            }
        });
    }
    remove(key) {
        return new Promise((resolve, reject) => {
            try {
                window.localStorage.removeItem(key);
                resolve();
            }
            catch (e) {
                reject(e);
            }
        });
    }
    clear() {
        return new Promise((resolve, reject) => {
            try {
                window.localStorage.clear();
                resolve();
            }
            catch (e) {
                reject(e);
            }
        });
    }
}
